<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_Discount ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_Discount extends AbstractStructArrayBase
{
    /**
     * The AdultAdditional
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_Discount[]
     */
    public $AdultAdditional;
    /**
     * Constructor method for ArrayOfJPSOAP_Discount
     * @uses ArrayOfJPSOAP_Discount::setAdultAdditional()
     * @param \StructType\JPSOAP_Discount[] $adultAdditional
     */
    public function __construct(array $adultAdditional = array())
    {
        $this
            ->setAdultAdditional($adultAdditional);
    }
    /**
     * Get AdultAdditional value
     * @return \StructType\JPSOAP_Discount[]|null
     */
    public function getAdultAdditional()
    {
        return $this->AdultAdditional;
    }
    /**
     * Set AdultAdditional value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount[] $adultAdditional
     * @return \ArrayType\ArrayOfJPSOAP_Discount
     */
    public function setAdultAdditional(array $adultAdditional = array())
    {
        foreach ($adultAdditional as $arrayOfJPSOAP_DiscountAdultAdditionalItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_DiscountAdultAdditionalItem instanceof \StructType\JPSOAP_Discount) {
                throw new \InvalidArgumentException(sprintf('The AdultAdditional property can only contain items of \StructType\JPSOAP_Discount, "%s" given', is_object($arrayOfJPSOAP_DiscountAdultAdditionalItem) ? get_class($arrayOfJPSOAP_DiscountAdultAdditionalItem) : gettype($arrayOfJPSOAP_DiscountAdultAdditionalItem)), __LINE__);
            }
        }
        $this->AdultAdditional = $adultAdditional;
        return $this;
    }
    /**
     * Add item to AdultAdditional value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount $item
     * @return \ArrayType\ArrayOfJPSOAP_Discount
     */
    public function addToAdultAdditional(\StructType\JPSOAP_Discount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_Discount) {
            throw new \InvalidArgumentException(sprintf('The AdultAdditional property can only contain items of \StructType\JPSOAP_Discount, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AdultAdditional[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_Discount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_Discount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdultAdditional
     */
    public function getAttributeName()
    {
        return 'AdultAdditional';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_Discount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
